---

- name: "1.1.1.[1,2,3,4] Ensure mounting of unused filesystems is disabled"
  become: true
  block:
    - name: "1.1.1.[1,2,3,4] Ensure unused module will be disabled"
      ansible.builtin.blockinfile:
        path: /etc/modprobe.d/{{ item }}.conf
        create: true
        mode: 0644
        block:
          install {{ item }} /bin/true
      loop: "{{ os_hardening_unused_filesystems }}"
    - name: "1.1.1.[1,2,3,4] Unload unused module"
      community.general.modprobe:
        name: "{{ item }}"
        state: absent
      # this does not work if a module is in use, so ignore_errors set to true
      ignore_errors: true
      loop: "{{ os_hardening_unused_filesystems }}"
  tags:
    - 1.1.1.1
    - 1.1.1.2
    - 1.1.1.3
    - 1.1.1.4

- name: "1.1.[2,3,4,5] Ensure /tmp is configured"
  become: true
  block:
    - name: "1.1.[2,3,4,5] Configure /tmp"
      ansible.posix.mount:
        path: /tmp
        src: tmpfs
        state: mounted
        fstype: tmpfs
        opts: "{{ os_hardening_tmp_partition_options }}"
    - name: "Unmask unit tmp.mount"
      ansible.builtin.systemd:
        name: tmp.mount
        masked: no
  tags:
    - 1.1.2
    - 1.1.3
    - 1.1.4
    - 1.1.5

- name: "1.1.[6,7,8,9] Ensure /dev/shm is configured"
  become: true
  ansible.posix.mount:
    path: /dev/shm
    src: tmpfs
    state: mounted
    fstype: tmpfs
    opts: "{{ os_hardening_dev_shm_partition_options }}"
  tags:
    - 1.1.6
    - 1.1.7
    - 1.1.8
    - 1.1.9

- name: 1.1.21 Ensure sticky bit is set on all world-writable directories
  ansible.builtin.shell: >
    set -eo pipefail
    /usr/bin/df --local -P
    | /usr/bin/awk '{if (NR!=1) print $6}'
    | /usr/bin/xargs -I '{}' /usr/bin/find '{}'
    -xdev -type d \( -perm -0002 -a ! -perm -1000 \) 2>/dev/null
    | /usr/bin/xargs -I '{}' /bin/chmod a+t '{}'
  changed_when: true
  tags:
    - 1.1.21

- name: 1.1.23 Disable USB Storage
  become: true
  block:
    - name: 1.1.23 Disable USB Storage (ensure module will be disabled)
      ansible.builtin.blockinfile:
        path: /etc/modprobe.d/usb_storage.conf
        create: true
        mode: 0644
        block:
          install usb-storage /bin/true
    - name: 1.1.23 Disable USB Storage (unload the module)
      community.general.modprobe:
        name: usb-storage
        state: absent
      ignore_errors: true
  tags:
    - 1.1.23
